From: Ojaswin Mujoo <ojaswin@linux.ibm.com>
To: Zorro Lang <zlang@redhat.com>, fstests@vger.kernel.org
Cc: Ritesh Harjani <ritesh.list@gmail.com>,
djwong@kernel.org, john.g.garry@oracle.com, tytso@mit.edu,
linux-xfs@vger.kernel.org, linux-kernel@vger.kernel.org,
linux-ext4@vger.kernel.org
Subject: [PATCH v3 05/13] generic/1226: Add atomic write test using fio crc check verifier
Date: Sat, 12 Jul 2025 19:42:47 +0530 [thread overview]
Message-ID: <1e6dad5f4bdc8107e670cc0bd3ce0fccd0c9037a.1752329098.git.ojaswin@linux.ibm.com> (raw)
In-Reply-To: <cover.1752329098.git.ojaswin@linux.ibm.com>
From: "Ritesh Harjani (IBM)" <ritesh.list@gmail.com>
This adds atomic write test using fio based on it's crc check verifier.
fio adds a crc for each data block. If the underlying device supports atomic
write then it is guaranteed that we will never have a mix data from two
threads writing on the same physical block.
Co-developed-by: Ritesh Harjani (IBM) <ritesh.list@gmail.com>
Signed-off-by: Ritesh Harjani (IBM) <ritesh.list@gmail.com>
Signed-off-by: Ojaswin Mujoo <ojaswin@linux.ibm.com>
---
tests/generic/1226 | 101 +++++++++++++++++++++++++++++++++++++++++
tests/generic/1226.out | 2 +
2 files changed, 103 insertions(+)
create mode 100755 tests/generic/1226
create mode 100644 tests/generic/1226.out
diff --git a/tests/generic/1226 b/tests/generic/1226
new file mode 100755
index 00000000..455fc55f
--- /dev/null
+++ b/tests/generic/1226
@@ -0,0 +1,101 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2025 IBM Corporation. All Rights Reserved.
+#
+# FS QA Test 1226
+#
+# Validate FS atomic write using fio crc check verifier.
+#
+. ./common/preamble
+. ./common/atomicwrites
+
+_begin_fstest auto aio rw atomicwrites
+
+_require_scratch_write_atomic
+_require_odirect
+_require_aio
+
+_scratch_mkfs >> $seqres.full 2>&1
+_scratch_mount
+
+touch "$SCRATCH_MNT/f1"
+awu_min_write=$(_get_atomic_write_unit_min "$SCRATCH_MNT/f1")
+awu_max_write=$(_get_atomic_write_unit_max "$SCRATCH_MNT/f1")
+blocksize=$(_max "$awu_min_write" "$((awu_max_write/2))")
+
+fio_config=$tmp.fio
+fio_out=$tmp.fio.out
+
+FIO_LOAD=$(($(nproc) * 2 * LOAD_FACTOR))
+SIZE=$((100 * 1024 * 1024))
+
+function create_fio_configs()
+{
+ create_fio_aw_config
+ create_fio_verify_config
+}
+
+function create_fio_verify_config()
+{
+cat >$fio_verify_config <<EOF
+ [verify-job]
+ direct=1
+ ioengine=libaio
+ rw=randwrite
+ bs=$blocksize
+ fallocate=native
+ filename=$SCRATCH_MNT/test-file
+ size=$SIZE
+ iodepth=$FIO_LOAD
+ group_reporting=1
+
+ verify_only=1
+ verify=crc32c
+ verify_fatal=1
+ verify_state_save=0
+ verify_write_sequence=0
+EOF
+}
+
+function create_fio_aw_config()
+{
+cat >$fio_aw_config <<EOF
+ [atomicwrite-job]
+ direct=1
+ ioengine=libaio
+ rw=randwrite
+ bs=$blocksize
+ fallocate=native
+ filename=$SCRATCH_MNT/test-file
+ size=$SIZE
+ iodepth=$FIO_LOAD
+ numjobs=$FIO_LOAD
+ group_reporting=1
+ atomic=1
+
+ verify_state_save=0
+ verify=crc32c
+ do_verify=0
+EOF
+}
+
+fio_aw_config=$tmp.aw.fio
+fio_verify_config=$tmp.verify.fio
+
+create_fio_configs
+_require_fio $fio_aw_config
+
+cat $fio_aw_config >> $seqres.full
+cat $fio_verify_config >> $seqres.full
+
+$FIO_PROG $fio_aw_config >> $seqres.full
+ret1=$?
+$FIO_PROG $fio_verify_config >> $seqres.full
+ret2=$?
+
+[[ $ret1 -eq 0 && $ret2 -eq 0 ]] || _fail "fio with atomic write failed"
+
+# success, all done
+echo Silence is golden
+status=0
+exit
diff --git a/tests/generic/1226.out b/tests/generic/1226.out
new file mode 100644
index 00000000..6dce0ea5
--- /dev/null
+++ b/tests/generic/1226.out
@@ -0,0 +1,2 @@
+QA output created by 1226
+Silence is golden
--
2.49.0
next prev parent reply other threads:[~2025-07-12 14:13 UTC|newest]
Thread overview: 60+ messages / expand[flat|nested] mbox.gz Atom feed top
2025-07-12 14:12 [PATCH v3 00/13] Add more tests for multi fs block atomic writes Ojaswin Mujoo
2025-07-12 14:12 ` [PATCH v3 01/13] common/rc: Add _min() and _max() helpers Ojaswin Mujoo
2025-07-17 15:02 ` Darrick J. Wong
2025-07-12 14:12 ` [PATCH v3 02/13] common/rc: Fix fsx for ext4 with bigalloc Ojaswin Mujoo
2025-07-17 16:11 ` Darrick J. Wong
2025-07-22 9:53 ` Ojaswin Mujoo
2025-07-23 14:50 ` Darrick J. Wong
2025-07-12 14:12 ` [PATCH v3 03/13] common/rc: Add a helper to run fsx on a given file Ojaswin Mujoo
2025-07-12 14:12 ` [PATCH v3 04/13] ltp/fsx.c: Add atomic writes support to fsx Ojaswin Mujoo
2025-07-17 16:17 ` Darrick J. Wong
2025-07-22 9:59 ` Ojaswin Mujoo
2025-07-23 14:57 ` Darrick J. Wong
2025-07-12 14:12 ` Ojaswin Mujoo [this message]
2025-07-17 13:00 ` [PATCH v3 05/13] generic/1226: Add atomic write test using fio crc check verifier John Garry
2025-07-17 13:52 ` Ojaswin Mujoo
2025-07-17 14:06 ` John Garry
2025-07-22 8:47 ` Ojaswin Mujoo
2025-07-23 11:33 ` John Garry
2025-07-23 13:51 ` Ojaswin Mujoo
2025-07-23 16:25 ` John Garry
2025-07-25 6:27 ` Ojaswin Mujoo
2025-07-25 8:14 ` John Garry
2025-07-28 6:43 ` Ojaswin Mujoo
2025-07-28 9:09 ` John Garry
2025-07-28 13:35 ` Ojaswin Mujoo
2025-07-28 14:00 ` John Garry
2025-07-29 6:11 ` Ojaswin Mujoo
2025-07-29 14:45 ` Darrick J. Wong
2025-07-31 4:18 ` Ojaswin Mujoo
2025-07-31 7:58 ` John Garry
2025-08-01 6:41 ` Ojaswin Mujoo
2025-08-01 8:23 ` John Garry
2025-08-02 6:49 ` Ojaswin Mujoo
2025-08-04 7:12 ` John Garry
2025-08-08 6:00 ` Ojaswin Mujoo
2025-07-12 14:12 ` [PATCH v3 06/13] generic/1227: Add atomic write test using fio verify on file mixed mappings Ojaswin Mujoo
2025-07-17 16:32 ` Darrick J. Wong
2025-07-28 8:58 ` Zorro Lang
2025-07-28 9:27 ` Ojaswin Mujoo
2025-07-12 14:12 ` [PATCH v3 07/13] generic/1228: Add atomic write multi-fsblock O_[D]SYNC tests Ojaswin Mujoo
2025-07-17 16:35 ` Darrick J. Wong
2025-07-23 13:53 ` Ojaswin Mujoo
2025-07-23 14:54 ` Darrick J. Wong
2025-08-10 9:41 ` Ojaswin Mujoo
2025-07-12 14:12 ` [PATCH v3 08/13] generic/1229: Stress fsx with atomic writes enabled Ojaswin Mujoo
2025-07-17 16:22 ` Darrick J. Wong
2025-07-23 6:30 ` Ojaswin Mujoo
2025-07-23 14:56 ` Darrick J. Wong
2025-07-12 14:12 ` [PATCH v3 09/13] generic/1230: Add sudden shutdown tests for multi block atomic writes Ojaswin Mujoo
2025-07-29 19:49 ` Darrick J. Wong
2025-07-12 14:12 ` [PATCH v3 10/13] ext4/061: Atomic writes stress test for bigalloc using fio crc verifier Ojaswin Mujoo
2025-07-29 19:47 ` Darrick J. Wong
2025-07-30 13:56 ` Ojaswin Mujoo
2025-07-12 14:12 ` [PATCH v3 11/13] ext4/062: Atomic writes test for bigalloc using fio crc verifier on multiple files Ojaswin Mujoo
2025-07-29 19:44 ` Darrick J. Wong
2025-07-12 14:12 ` [PATCH v3 12/13] ext4/063: Atomic write test for extent split across leaf nodes Ojaswin Mujoo
2025-07-29 19:41 ` Darrick J. Wong
2025-07-30 14:06 ` Ojaswin Mujoo
2025-07-12 14:12 ` [PATCH v3 13/13] ext4/064: Add atomic write tests for journal credit calculation Ojaswin Mujoo
2025-07-29 19:36 ` Darrick J. Wong
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1e6dad5f4bdc8107e670cc0bd3ce0fccd0c9037a.1752329098.git.ojaswin@linux.ibm.com \
--to=ojaswin@linux.ibm.com \
--cc=djwong@kernel.org \
--cc=fstests@vger.kernel.org \
--cc=john.g.garry@oracle.com \
--cc=linux-ext4@vger.kernel.org \
--cc=linux-kernel@vger.kernel.org \
--cc=linux-xfs@vger.kernel.org \
--cc=ritesh.list@gmail.com \
--cc=tytso@mit.edu \
--cc=zlang@redhat.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox
all inboxes | Powered by JetHome®